function [fig] = vp_plot(im, horizon_line, show_horizon_line, horizon_vp, zenith, lines, vp_association)
fig = figure();
imshow(im); hold on;


for i = 1:size(lines,1)
    centroid(i,1) = (lines(i,1)+lines(i,3))/2;
    centroid(i,2) = (lines(i,2)+lines(i,4))/2;
    if vp_association(i) == 0
        bundle_line = [zenith(1,1) zenith(1,2) centroid(i,1) centroid(i,2)];
        if zenith(1,3) > 0
            col1 = ':b';
            col2 = '-b';
        else
            col1 = ':m';
            col2 = '-m';
        end
        plot([bundle_line(1);bundle_line(3)],[bundle_line(2);bundle_line(4)], col1);
        plot([lines(i,1);lines(i,3)],[lines(i,2);lines(i,4)], col2, 'LineWidth', 1);       
    else
        v = vp_association(i);
        if v > 0
            bundle_line = [horizon_vp(v,1) horizon_vp(v,2) centroid(i,1) centroid(i,2)];
            if (zenith(1,3) == 0 && v == 1) || (v == zenith(1,3))
                plot([bundle_line(1);bundle_line(3)],[bundle_line(2);bundle_line(4)], ':r');
                plot([lines(i,1);lines(i,3)],[lines(i,2);lines(i,4)], '-r', 'LineWidth', 1);           
            else
                if (v == zenith(1,4))
                    plot([bundle_line(1);bundle_line(3)],[bundle_line(2);bundle_line(4)], ':g');
                    plot([lines(i,1);lines(i,3)],[lines(i,2);lines(i,4)], '-g', 'LineWidth', 1);                   
                else
                    ax = gca;
                    ax.ColorOrderIndex = v;
                    plot([bundle_line(1);bundle_line(3)],[bundle_line(2);bundle_line(4)],':');
                    ax.ColorOrderIndex = v;
                    plot([lines(i,1);lines(i,3)],[lines(i,2);lines(i,4)], '-', 'LineWidth', 1);
                end
            end
        end
    end
end

width = size(im, 2);
hl = horizon_line;
hl_a=hl(1);
hl_b=hl(2);
hl_c=hl(3);
hlp(1,1) = 1;
hlp(1,2) = -hl_c/hl_b;
hlp(1,3) = width;
hlp(1,4) = -(hl_a*width+hl_c)/hl_b;
if show_horizon_line
    plot([hlp(1,1);hlp(1,3)],[hlp(1,2);hlp(1,4)], '-y', 'LineWidth', 4);
else    
    plot([hlp(1,1);hlp(1,3)],[hlp(1,2);hlp(1,4)], '--y', 'LineWidth', 1);
end

drawnow();
